package com.cim.idm.framework.banner;

import java.io.PrintStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.boot.Banner;
import org.springframework.boot.ansi.AnsiColor;
import org.springframework.boot.ansi.AnsiOutput;
import org.springframework.boot.ansi.AnsiStyle;
import org.springframework.core.env.Environment;

import com.cim.idm.framework.util.sys.SystemPropHelper;

public class BIDMBanner implements Banner{
	private Log log = LogFactory.getLog(BIDMBanner.class);
	private final String banner = /*" ----------------------------------------"+SystemPropHelper.CR+*/
			SystemPropHelper.CR+ 
"███████╗██╗██████╗ ███╗   ███╗██╗ ██╗ ██╗"+SystemPropHelper.CR+
"╚══███╔╝██║██╔══██╗████╗ ████║╚██╗╚██╗╚██╗" +SystemPropHelper.CR+
"  ███╔╝ ██║██║  ██║██╔████╔██║ ╚██╗╚██╗╚██╗"+SystemPropHelper.CR+
" ███╔╝  ██║██║  ██║██║╚██╔╝██║ ██╔╝██╔╝██╔╝"+SystemPropHelper.CR+
"███████╗██║██████╔╝██║ ╚═╝ ██║██╔╝██╔╝██╔╝"+SystemPropHelper.CR+ 
"╚══════╝╚═╝╚═════╝ ╚═╝     ╚═╝╚═╝ ╚═╝ ╚═╝"+SystemPropHelper.CR+  

			 " - ZXY Intelligent Digital Manufacturing  -"+SystemPropHelper.CR+
			 " ------------------------------------------";
	private static final String BIDM_BOOT = " :: ZIDM Boot :: ";

	private static final int STRAP_LINE_SIZE = 42;

	@Override
	public void printBanner(Environment environment, Class<?> sourceClass, PrintStream out) {
//		out.println(banner);
		Package pkg = this.getClass().getPackage();
		String version = (pkg != null) ? pkg.getImplementationVersion() : null;
		version = (version != null) ? " (v" + version + ")" : "";
		StringBuilder padding = new StringBuilder();
		
		while (padding.length() < STRAP_LINE_SIZE - (version.length() + BIDM_BOOT.length())) {
			padding.append(" ");
		}
		log.info(SystemPropHelper.CR
				+AnsiOutput.toString(AnsiColor.BRIGHT_BLUE, banner.toString())
				+SystemPropHelper.CR+AnsiOutput.toString(AnsiColor.GREEN, BIDM_BOOT, AnsiColor.DEFAULT, padding.toString(),
						AnsiStyle.FAINT, version)
				+SystemPropHelper.CR);
		
		
	}
}
