package com.cim.idm.framework.fos.idmflow;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jdom.Document;
import org.jdom.Element;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.transaction.TransactionException;

import com.cim.idm.flowpackage.core.BpelActivityListener;
import com.cim.idm.flowpackage.core.activity.Activity;
import com.cim.idm.flowpackage.core.activity.BpelProcess;
import com.cim.idm.flowpackage.core.activity.Case;
import com.cim.idm.flowpackage.core.activity.Sequence;
import com.cim.idm.framework.IDMFrameServiceProxy;
import com.cim.idm.framework.transaction.TransactionManager;
import com.cim.idm.framework.util.service.ServiceUtil;
import com.cim.idm.framework.util.sys.SystemPropHelper;
import com.cim.idm.framework.util.wf.WFUtil;
import com.cim.idm.framework.util.xml.JdomUtils;



public class BpelExecutionEventAdaptor implements BpelActivityListener
{
	protected static Log		log				= LogFactory.getLog(BpelExecutionEventAdaptor.class);
	private String				rootBpelName	= "";
	private boolean				docview			= false;

	private ActivityManager		activityManager	= new ActivityManager();

	private BpelExRepository	bpelRepository;

	public boolean isDocview()
	{
		return docview;
	}

	public void setDocview(boolean docview)
	{
		this.docview = docview;
	}

	public BpelExRepository getBpelRepository()
	{
		return bpelRepository;
	}

	public void setBpelRepository(BpelExRepository bpelRepository)
	{
		this.bpelRepository = bpelRepository;
	}

	public String getRootBpelName()
	{
		return this.rootBpelName;
	}
	
	public void onEnd(Activity activity)
	{
		if (activity instanceof BpelProcess)
		{
			BpelProcess process = (BpelProcess) activity;
			if (rootBpelName == null || rootBpelName.length() == 0)
			{
				// commit
				commitTransaction();

				if (process.getThrowable() == null)
				{
					log.info("===============================================================================================");
					log.info(BpelLogger.bpel_ended + summaryData(process, false));
					log.info("===============================================================================================");

					if (IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor") != null)
					{
						BpelMonitor bpelMonitor = (BpelMonitor) IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor");
						
						if (bpelMonitor.isAutoManaged())
						{
							List arrayList = activityManager.getActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName()).getActivityList();
							bpelMonitor.sendMonitorData(process, arrayList, WFUtil.getDocumentbyOriginator(process.getBpelExecutionContext()), true);
							activityManager.removeActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName());
						}
					}
				}
				else
				{
					log.info("===============================================================================================");
					log.info(BpelLogger.bpel_ended + summaryData(process, true));
					log.info("===============================================================================================");

					if (IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor") != null)
					{
						BpelMonitor bpelMonitor = (BpelMonitor) IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor");
						
						if (bpelMonitor.isAutoManaged())
						{
							List arrayList = activityManager.getActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName()).getActivityList();
							bpelMonitor.sendMonitorData(process, arrayList, WFUtil.getDocumentbyOriginator(process.getBpelExecutionContext()), false);
							activityManager.removeActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName());
						}
					}
				}
			} 
			else //not if (rootBpelName == null || rootBpelName.length() == 0)
			{
				if (!process.getName().equalsIgnoreCase(rootBpelName))
				{
					if (process.getThrowable() == null)
					{
						log.info("===============================================================================================");
						log.info(BpelLogger.bpel_ended + summaryData(process, false));
						log.info("===============================================================================================");
						try
						{
							if (IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor") != null)
							{
								BpelMonitor bpelMonitor = (BpelMonitor) IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor");
								
								if (bpelMonitor.isAutoManaged())
								{
									List arrayList = activityManager.getActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName()).getActivityList();
									bpelMonitor.sendMonitorData(process, arrayList, WFUtil.getDocumentbyOriginator(process.getBpelExecutionContext()), true);
									activityManager.removeActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName());
								}
							}
						} catch (Exception e)
						{}
					}
					// Fail
					else
					{
						log.info("===============================================================================================");
						log.info(BpelLogger.bpel_ended + summaryData(process, true));
						log.info("===============================================================================================");

						try
						{
							if (IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor") != null)
							{
								BpelMonitor bpelMonitor = (BpelMonitor) IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor");
								
								if (bpelMonitor.isAutoManaged())
								{
									List arrayList = activityManager.getActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName()).getActivityList();
									bpelMonitor.sendMonitorData(process, arrayList, WFUtil.getDocumentbyOriginator(process.getBpelExecutionContext()), false);
									activityManager.removeActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName());
								}
							}
						} catch (Exception e)
						{}
					}
				}
				else ////not if (rootBpelName == null || rootBpelName.length() == 0) && if (!process.getName().equalsIgnoreCase(rootBpelName))
				{
					// commit
					commitTransaction();

					try
					{
						if (IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor") != null)
						{
							BpelMonitor bpelMonitor = (BpelMonitor) IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor");
							
							if (bpelMonitor.isAutoManaged())
							{
								List arrayList = activityManager.getActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName()).getActivityList();
								bpelMonitor.sendMonitorData(process, arrayList,	WFUtil.getDocumentbyOriginator(process.getBpelExecutionContext()), true);
								activityManager.removeActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName());
							}
						}
					} 
					catch (Exception e)
					{}
				}
			}

			/*
			 * else { try { HynixController HynixController =
			 * (HynixController)BaseController.getInstance
			 * ().getContext().getBean("HynixController"); HynixController.release(); } catch
			 * (Exception e) {} }
			 */
		}
		else // Activity not BpelProcess
		{
			if (activity.getName() != null && activity.getName().length() > 0)
			{
				if (IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor") != null)
				{
					BpelMonitor bpelMonitor = (BpelMonitor) IDMFrameServiceProxy.getApplicationContext().getBean("BpelMonitor");
					
					if (bpelMonitor.isAutoManaged())
					{
						Element element = new Element("activity");
						element.setAttribute("name", activity.getName());
						element.setAttribute("starttime", BpelMonitor.getStandardTime(activity.getStartTime()));
						element.setAttribute("endtime", BpelMonitor.getStandardTime(activity.getEndTime()));
						element.setAttribute("elapsetime", String.valueOf(activity.getEndTime().getTime() - activity.getStartTime().getTime()));
						List arrayList = activityManager.getActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName()).getActivityList();
						arrayList.add(element);
					}
				}
			}
		}
	}

	public void onException(Activity activity, Exception arg1)
	{
		if ( arg1.getCause() instanceof Error )
		{
			log.fatal( arg1.getCause().toString() + "   " + activity.getInfo());
			System.exit( -1 );
		}
		
		log.error(arg1, arg1);

		// rollback
		rollbackTransaction();
	}

	public void onInterrupt(Activity arg0)
	{
		log.warn("Interrupt : " + arg0.getName());
	}

	public void onStart(Activity activity)
	{
		if (rootBpelName.length() == 0)
		{
			rootBpelName = getBpelRepository().getRootBpelName();
		}
		
		//if(activity instanceof BpelProcess) 		
		if (activity instanceof Sequence)
		{
			if (!activityManager.isExist(Thread.currentThread().getId(), activity.getBpelProcess().getName()))
			{
				ActivityHandler ActivityHandler = new ActivityHandler();
				activityManager.addActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName(),	ActivityHandler);
				activityManager.getActivityHandler(Thread.currentThread().getId(), activity.getBpelProcess().getName()).setBpelStarted(true);
			}

			if (rootBpelName == null || rootBpelName.length() == 0)
			{
				try
				{
					log.info("===============================================================================================");
					log.info(BpelLogger.bpel_started
						+ activity.getBpelProcess().getName()
						+ "@"
						+ activity.getBpelProcess().getId()
						+ " ");
					log.info("===============================================================================================");
					writeDocument(activity.getBpelProcess());
				} catch (Exception e)
				{}

				try
				{
					beginTransaction();
				}
				catch ( TransactionException ex )
				{
					activity.onException( activity, ex );
				}
			}
			else
			{
				if (!activity.getBpelProcess().getName().equalsIgnoreCase(rootBpelName))
				{
					log.info("===============================================================================================");
					log.info(BpelLogger.bpel_started
						+ activity.getBpelProcess().getName()
						+ "@"
						+ activity.getBpelProcess().getId()
						+ " ");
					log.info("===============================================================================================");
					writeDocument(activity.getBpelProcess());
				}
				else
				{
					try
					{
						beginTransaction();
					}
					catch ( TransactionException ex )
					{
						activity.onException( activity, ex );
					}
				}
			}
		}
		else //not Sequnece
		{
			if (activity instanceof BpelProcess)
				return;
			try
			{
				if (activity.getName() == null || activity.getName().length() == 0)
					return;
			} catch (Exception e)
			{}
			try
			{
				BpelProcess bpelProcess = activity.getBpelProcess();
				/*
				 * if (log.isDebugEnabled()) log.debug(LogConstant.bpel_activity_started +
				 * activity.getBpelProcess().getId() + activity.getInfo()); else
				 * log.info(LogConstant.bpel_activity_started + bpelProcess.getName() + " :: " +
				 * activity.getName());
				 */

				String logStr = bpelProcess.getName() + "@" + bpelProcess.getId() + " :: " + activity.getName();

				if (activity instanceof Case)
					logStr += " [" + ((Case) activity).getCondition() + "]";

				log.info(BpelLogger.bpel_activity_started + logStr);
			} 
			catch (Exception e)
			{
				log.debug(BpelLogger.bpel_activity_started + activity.getInfo());
			}
		}
	}

	public void onTimeout(Activity arg0)
	{
		// TODO Auto-generated method stub
	}

	/*
	 * private String summaryBpel(BpelProcess bpelProcess) { try { Document document =
	 * WFUtil.getDocumentbyOriginator(bpelProcess.getBpelExecutionContext()); String listen_process
	 * = MessageUtil.getHeaderItemValue(document, MessageUtil.Header_Listen_Process); String
	 * equipmentid = ""; String lotName = ""; if (listen_process.startsWith("EIS")) { try { Element
	 * element = JdomUtils.getNode(document, "//Body/DATA"); equipmentid =
	 * element.getAttributeValue("EQUIPMENT_ID"); if (equipmentid == null) equipmentid = ""; } catch
	 * (Exception e) {} try { Element element = JdomUtils.getNode(document, "//LOT"); lotName =
	 * element.getAttributeValue("LOT_ID"); } catch (Exception e) {} } else { equipmentid =
	 * MessageUtil.getBodyItemValue(document, "MachineId"); lotName =
	 * MessageUtil.getBodyItemValue(document, "LotId"); }
	 * 
	 * return "[" + LogConstant.bpel_equipmentid + "=" + equipmentid + " " +
	 * LogConstant.bpel_lotname + "=" + lotName + "]"; } catch (Exception e) {} return ""; }
	 */

	protected void writeDocument(BpelProcess bpelProcess)
	{
		try
		{
			if (docview)
			{
				Document document = WFUtil.getDocumentbyOriginator(bpelProcess.getBpelExecutionContext());
				log.info(BpelLogger.bpel_req_message
					+ bpelProcess.getName()
					+ "@"
					+ bpelProcess.getId()
					+ " "
					+ SystemPropHelper.CR
					+ JdomUtils.toString(document));
			}
		} 
		catch (Exception e)
		{}
	}

	protected String summaryData(BpelProcess process, boolean fail)
	{
		StringBuffer stringbuffer = new StringBuffer();
		
		if (!fail)
		{
			stringbuffer.append(process.getName()).append("@").append(process.getId()).append(" <SUCCESS> ");
			stringbuffer.append(" Elapsed Time = ").append(
				(process.getEndTime().getTime() - process.getStartTime().getTime())).append(" miliseconds");
		}
		else
		{
			stringbuffer.append(process.getName()).append("@").append(process.getId()).append(" <FAIL> ");
			stringbuffer.append(" Elapsed Time = ").append(
				(process.getEndTime().getTime() - process.getStartTime().getTime())).append(" miliseconds");
		}
		
		return stringbuffer.toString();
	}

	protected void beginTransaction()
	{
		List<TransactionManager> trxManagers = ServiceUtil.getServices(IDMFrameServiceProxy.getApplicationContext(),TransactionManager.class);

		if (trxManagers != null)
		{
			for (Object obj : trxManagers)
			{
				TransactionManager trxManager = (TransactionManager) obj;
				if (trxManager.isAutoManaged())
					trxManager.beginTransaction();
			}
		}
	}

	protected void commitTransaction()
	{
		List<TransactionManager> trxManagers = ServiceUtil.getServices(IDMFrameServiceProxy.getApplicationContext(),TransactionManager.class);

		if (trxManagers != null)
		{
			for (Object obj : trxManagers)
			{
				TransactionManager trxManager = (TransactionManager) obj;
				if (trxManager.isAutoManaged())
					trxManager.commitAllTransactions();
			}
		}
	}

	protected void rollbackTransaction()
	{
		List<TransactionManager> trxManagers = ServiceUtil.getServices(IDMFrameServiceProxy.getApplicationContext(),TransactionManager.class);

		if (trxManagers != null)
		{
			for (Object obj : trxManagers)
			{
				TransactionManager trxManager = (TransactionManager) obj;
				if (trxManager.isAutoManaged())
					trxManager.rollbackAllTransactions();
			}
		}
	}
}

class ActivityManager
{
	private Hashtable<String, ActivityHandler>	avtivities	= new Hashtable<String, ActivityHandler>();

	public boolean isExist(long threadid, String bpelName)
	{
		return avtivities.containsKey((String.valueOf(threadid) + "," + bpelName));
	}

	public ActivityHandler getActivityHandler(long threadid, String bpelName)
	{
		return avtivities.get(String.valueOf(threadid) + "," + bpelName);
	}

	public void removeActivityHandler(long threadid, String bpelName)
	{
		avtivities.get(String.valueOf(threadid) + "," + bpelName).getActivityList().clear();
		avtivities.remove((String.valueOf(threadid) + "," + bpelName));
	}

	public void addActivityHandler(long threadid, String bpelName, ActivityHandler ah)
	{
		avtivities.put((String.valueOf(threadid) + "," + bpelName), ah);
	}

}

class ActivityHandler
{
	private List<Element>	activityList	= new ArrayList<Element>();
	private boolean			bpelStarted		= false;

	public List<Element> getActivityList()
	{
		return activityList;
	}

	public void setActivityList(List<Element> activityList)
	{
		this.activityList = activityList;
	}

	public boolean isBpelStarted()
	{
		return bpelStarted;
	}

	public void setBpelStarted(boolean bpelStarted)
	{
		this.bpelStarted = bpelStarted;
	}
}
