package com.cim.idm.framework.orm;

import java.io.InputStream;
import java.io.Reader;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Types;

import org.springframework.jdbc.core.SqlTypeValue;
import org.springframework.jdbc.core.support.SqlLobValue;
import org.springframework.jdbc.support.lob.LobHandler;

public class GenSqlLobValue extends SqlLobValue
{
	private int	lobSqlType	= Types.OTHER;

	public GenSqlLobValue(byte[] bytes)
	{
		super(bytes);
		this.lobSqlType = Types.BLOB;
	}

	public GenSqlLobValue(byte[] bytes, LobHandler lobHandler)
	{
		super(bytes, lobHandler);
		this.lobSqlType = Types.BLOB;
	}

	public GenSqlLobValue(String content)
	{
		super(content);
		this.lobSqlType = Types.CLOB;
	}

	public GenSqlLobValue(String content, LobHandler lobHandler)
	{
		super(content, lobHandler);
		this.lobSqlType = Types.CLOB;
	}

	public GenSqlLobValue(InputStream stream, int length)
	{
		super(stream, length);
	}

	public GenSqlLobValue(InputStream stream, int length, LobHandler lobHandler)
	{
		super(stream, length, lobHandler);
	}

	public GenSqlLobValue(Reader reader, int length)
	{
		super(reader, length);
	}

	public GenSqlLobValue(Reader reader, int length, LobHandler lobHandler)
	{
		super(reader, length, lobHandler);
	}

	@Override
	public void setTypeValue(PreparedStatement ps, int paramIndex, int sqlType, String typeName) throws SQLException
	{
		if (sqlType == SqlTypeValue.TYPE_UNKNOWN)
		{
			sqlType = this.lobSqlType;
		}

		super.setTypeValue(ps, paramIndex, sqlType, typeName);
	}
}
