package com.cim.idm.framework.orm;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.Map;

import org.springframework.core.CollectionFactory;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.support.JdbcUtils;
import org.springframework.util.LinkedCaseInsensitiveMap;

public class GenericRowMapper implements RowMapper<Map<String, Object>>
{
	@Override
	public Map<String, Object> mapRow(ResultSet rs, int row) throws SQLException
	{
		ResultSetMetaData rsmd = rs.getMetaData();
		int columnCount = rsmd.getColumnCount();

		Map<String, Object> rowMap = CollectionFactory.createMap(LinkedCaseInsensitiveMap.class, columnCount);
//				CollectionFactory.createLinkedCaseInsensitiveMapIfPossible(columnCount);

		for (int i = 1; i <= columnCount; i++)
		{
			String key = JdbcUtils.lookupColumnName(rsmd, i);
			Object obj = JdbcUtils.getResultSetValue(rs, i);

			if (obj == null && String.class.getName().equals(rs.getMetaData().getColumnClassName(i)))
				obj = "";

			rowMap.put(key, obj);
		}

		return rowMap;
	}
}
