package com.cim.idm.framework.orm;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;

public class InsertWithSelect {
	// Insert into historyTableName()
	// select  
	// from tableName 
	// where condition 
	// 需要注意的地方是old字段都采用old数据， 这个old数据都在传递的参数中， 而old相对应的新的字段的值则在新的字段中， 新字段可以通过查询非历史表获得
	// 对于eventInfo相关的数据，则直接送到历史表中便是 lastevent开头，要换成event开头， 
	//
	private String  insertTableName;
	private String  selectTableName;
	private List<LinkedHashMap<String, String>> ORConditionMapList = new ArrayList<LinkedHashMap<String,String>>();
	private List<String> insertColumns = new ArrayList<String>();
	private List<String> selectColumns = new ArrayList<String>();
	
	public InsertWithSelect() {}
	
	public InsertWithSelect setInsertTableName(String insertTableName) {
		this.insertTableName = insertTableName;
		return this;
	}
	
	public InsertWithSelect setSelectTableName(String selectTableName){
		this.selectTableName = selectTableName;
		return this;
	}

	public InsertWithSelect setColumns(LinkedHashMap<String, String> columnsMap){
		for(String key :columnsMap.keySet()){
			insertColumns.add(key);
			selectColumns.add(columnsMap.get(key));
		}
			
		return this;
	}
	
	public InsertWithSelect setORConditionMapList(List<List<String>> ORConditionColumnNames){
		this.ORConditionMapList.clear();
		for(List<String> ColumnNames : ORConditionColumnNames){
			LinkedHashMap<String, String> ORConditionMap = new LinkedHashMap<String,String>();
			for(String ColumnName : ColumnNames){
				ORConditionMap.put(ColumnName, "=?");
			}
			ORConditionMapList.add(ORConditionMap);	
		}
		return this;
	}
	
	public String toInsertSelectFromStatementString() {
		StringBuilder sb = new StringBuilder();
		sb.append("INSERT INTO ").append(insertTableName.toUpperCase()).append("(");
		//insert column
		for(String insertColumnName :insertColumns){
			sb.append(insertColumnName.toUpperCase()).append(", ");
		}
		sb.delete(sb.length()-2, sb.length());
		sb.append(")");
		sb.append(" SELECT ");
		//select column
		for(String selectColumnName : selectColumns){
			sb.append(selectColumnName.toUpperCase()).append(", ");
		}
		sb.delete(sb.length()-2, sb.length());
		sb.append(" FROM ").append(selectTableName.toUpperCase());
		sb.append(" WHERE ");
		Iterator iter = null;
		if(!this.ORConditionMapList.isEmpty()){
			sb.append("(");
			if(ORConditionMapList.size()>1)
				sb.append("(");
			ListIterator<LinkedHashMap<String,String>> listIter = ORConditionMapList.listIterator();
			while(listIter.hasNext()){
				
				Map<String, String> ORConditionMap = listIter.next();
				
				iter = ORConditionMap.entrySet().iterator();
				while(iter.hasNext()){
					Map.Entry e = (Map.Entry) iter.next();
					sb.append( e.getKey() ).append( e.getValue() );
					if ( iter.hasNext() ) {
						sb.append( " and " );
					}
				}
	
				if(listIter.hasNext())
					sb.append(") or (");
				else
					if(ORConditionMapList.size()>1)
						sb.append(")");
			}
			sb.append(")");
		}
		return sb.toString();

	}

	public InsertWithSelect setInsertColumnNames(String[] insertColumnNames) {
		this.insertColumns = Arrays.asList(insertColumnNames);
		return this;
		
	}
	
	public InsertWithSelect setSelectColumns(String[] columns){
		this.selectColumns = Arrays.asList(columns);
		return this;
	}
	
/*	public String toStatementString(){
		StringBuilder sb = new StringBuilder();
		sb.append("INSERT INTO ").append(tableName).append("(");
		
		sb.append(" ) ");
		sb.append("Values").append("(");
		
		sb.append(" )");
		return sb.toString();
	}*/
}
