package com.cim.idm.framework.orm;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Types;
import java.util.Map;

import org.springframework.jdbc.core.ColumnMapRowMapper;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.support.JdbcUtils;



public class NullReplaceableRowMapper extends ColumnMapRowMapper implements RowMapper<Map<String, Object>>
{
	@Override
	public Map<String, Object> mapRow( ResultSet rs, int rowNum ) throws SQLException
	{
		ResultSetMetaData rsmd = rs.getMetaData();
		int columnCount = rsmd.getColumnCount();
		Map<String,Object> mapOfColValues = createColumnMap( columnCount );
		
		for ( int i = 1; i <= columnCount; i++ )
		{
			String key = getColumnKey( JdbcUtils.lookupColumnName( rsmd, i ) );
			Object obj = getColumnValue( rs, i );
			
			int type = rsmd.getColumnType( i );
			if ( obj == null && ( Types.VARCHAR == type || Types.NVARCHAR  == type ))
				obj = "";
			
			mapOfColValues.put( key, obj );
		}
		
		return mapOfColValues;
	}
}
