package com.cim.idm.framework.orm;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map.Entry;

import org.apache.commons.collections4.CollectionUtils;

import com.cim.idm.framework.orm.info.SelectColumn;

public class PersistentClass implements Serializable {

	private Class clazz;

	private ArrayList args = new ArrayList();

	private ArrayList<String> whereColumnNames = new ArrayList<String>();

	private ArrayList<Boolean> whereColumnNullness = new ArrayList<Boolean>();

	private ArrayList whereColumnArgs = new ArrayList();

	private ArrayList<String> updateColumnNames = new ArrayList<String>();

	private ArrayList updateColumnArgs = new ArrayList();

	private List<List<String>> whereORConditionMapList =new  ArrayList<List<String>>();
	
	private String[] keyColumns;

	private List<String> insertColumnNames = new ArrayList<String>();
	
	private List<String> selectColumns = new ArrayList<String>();
	
	private List<Object> selectColumnArgs = new ArrayList<Object>();
	
	private boolean needHistory = false;
	
	public Class getRegisterClass() {
		return clazz;
	}

	public void registerClass(Class clazz) {
		this.clazz = clazz;
	}
	public void setWhereORConditionMapList(List<LinkedHashMap<String,Object>> whereORConditionMapList){
		for(LinkedHashMap<String,Object> whereORConditionMap : whereORConditionMapList){
			addWhereORConditionMap(whereORConditionMap);
		}
	}
	
	public void addWhereORConditionMap(LinkedHashMap<String,Object> whereORConditionMap){
		List<String> orConditionMap = new ArrayList<String>();
		for(Entry<String, Object> entry :whereORConditionMap.entrySet()){
			orConditionMap.add(entry.getKey());
			whereColumnNullness.add(entry.getValue() != null ? true : false);
			whereColumnArgs.add(entry.getValue());
		}
		whereORConditionMapList.add(orConditionMap);
		
	}
	
	public void addUpdateMetaAttribute(MetaAttribute m) {
		int index = updateColumnNames.indexOf(m.getName());
		if(index >= 0) {
			updateColumnNames.remove(index);
			updateColumnArgs.remove(index);
		}
		updateColumnNames.add(m.getName());
		updateColumnArgs.add(m.getValue());
	}

	public void addWhereMetaAttribute(MetaAttribute m) {
		whereColumnNames.add(m.getName());
		whereColumnNullness.add(m.getValue() != null ? true : false);
		whereColumnArgs.add(m.getValue());
	}

	public String getEntityName() {
		return clazz.getSimpleName().intern();
	}

	public String[] getKeyColumns() {
		Field[] keyFields;
		try {
			keyFields = Class.forName(getEntityName() + "Key")
					.getDeclaredFields();
		} catch (Exception e) {
			throw new RuntimeException("Wrong className ["
					+ clazz.getSimpleName() + "]");
		}
		keyColumns = new String[keyFields.length];
		for (int i = 0; i < keyFields.length; i++) {
			keyColumns[i] = keyFields[i].getName();
		}
		return keyColumns;
	}

	public void setInsertColumns(List<String> insertColumnNames){
		this.insertColumnNames = insertColumnNames;
	}
	
	public void setSelectColumns(List<String> selectColumns){
		this.selectColumns = selectColumns;
	}
	
	public void setSelectColumnArgs(List<Object> selectColumnArgs){
		this.selectColumnArgs = selectColumnArgs;
	}
	
	public void setInsertSelectColumns(LinkedHashMap<String, SelectColumn> insertSelectColumns){
		for(String insertColumn : insertSelectColumns.keySet()){
			insertColumnNames.add(insertColumn);
			SelectColumn selectColumn = insertSelectColumns.get(insertColumn);
			String columnName = selectColumn.getColumnName();
			if(columnName==null) 
				columnName= "";
			String asColumnName = selectColumn.getAsColumnName();
			Object replaceValue = selectColumn.getReplaceValue();
			boolean isReplaceValue = false;
			if(replaceValue!=null){
				selectColumnArgs.add(replaceValue);
				isReplaceValue = true;
			}

			if(asColumnName!=null && !asColumnName.isEmpty())
				if(isReplaceValue)
					selectColumns.add("? as " +"\"" +asColumnName.toUpperCase() +"\"");
				else
					selectColumns.add(columnName +" as " +"\"" +asColumnName.toUpperCase() +"\"" );
			else
				selectColumns.add(columnName);
		}
		this.needHistory = true;
	}
	
	public boolean getNeedHistory() {
		return needHistory;
	}
	
	public void setNeedHistory(boolean needHistory){
		this.needHistory = needHistory;
	}
	
	public String[] getInsertColumnNames(){
		return this.insertColumnNames.toArray(new String[insertColumnNames.size()]);
	}

	public String[] getSelectColumns(){
		return this.selectColumns.toArray(new String[selectColumns.size()]);
	}
	
	public List<List<String>> getWhereORConditionMapList(){
		return this.whereORConditionMapList;
	}
	
	public Boolean[] getWhereColumnNullness() {
		return whereColumnNullness.toArray(new Boolean[whereColumnNullness.size()]);
	}

	public String[] getWhereColumnNames() {
		// TODO Auto-generated method stub
		return whereColumnNames.toArray(new String[whereColumnNames.size()]);
	}

	public String[] getUpdateColumnNames() {
		return updateColumnNames.toArray(new String[updateColumnNames.size()]);
	}

	public Object[] getArgs() {
		args.clear();
		CollectionUtils.addAll(args, updateColumnArgs.iterator());
		CollectionUtils.addAll(args, whereColumnArgs.iterator());
		return args.toArray(new Object[args.size()]);
	}
	public Object[] getUpdateArgs(){
		return getArgs();
	}
	
	public Object[] getInsertSelectArgs(){
		args.clear();
		CollectionUtils.addAll(args, selectColumnArgs.iterator());
		CollectionUtils.addAll(args, whereColumnArgs.iterator());
		return args.toArray(new Object[args.size()]);
	}
}
