package com.cim.idm.framework.orm;

import java.util.List;

public class SqlGenerator {

	private PersistentClass persistentClass;
	
	
	public SqlGenerator(PersistentClass persistentClass) {
		super();
		this.persistentClass = persistentClass;
	}

	protected String getTableName() {
		return persistentClass.getRegisterClass().getSimpleName().toUpperCase();
	}

	protected String[] getKeyColumns() {
		return persistentClass.getKeyColumns();
	}
	
	public List<List<String>> getORConditionsMapList(){
		return persistentClass.getWhereORConditionMapList();
	}
	/*
	 * public Type[] getPropertyTypes() { return
	 * persistentClass.getPropertyTypes(); }
	 */

	public String[] getWhereColumnNames() {
		return persistentClass.getWhereColumnNames();
	}
	
	public Boolean[] getWhereColumnNullness(){
		return persistentClass.getWhereColumnNullness();
	}
	
	public String[] getUpdateColumnNames(){
		return persistentClass.getUpdateColumnNames();
	}
	
	/**
	 * Generate the SQL that updates a row by id (and version)
	 */
	public String generateUpdateString() {

		Update update = new Update().setTableName(getTableName());
		update.addColumns(getUpdateColumnNames());
		List<List<String>> ORConditionMapList = getORConditionsMapList();
		update.setORConditionMapList(ORConditionMapList);
		int count = 0;
		for(int i = 0 ; i < ORConditionMapList.size() ; i++){
			count += ORConditionMapList.get(i).size();
		}
		String[] whereColumnNames = getWhereColumnNames();
		Boolean[] propertyNullness = getWhereColumnNullness();
		for (int k = count; k < propertyNullness.length; k++) {
			if (propertyNullness[k]) {
				update.addWhereColumn(whereColumnNames[k-count].toUpperCase(), "=?");
			} else {
				update.addWhereColumn(whereColumnNames[k-count].toUpperCase(), " is null");
			}
		}
		return update.toStatementString();
	}
	
	public Object[] getUpdateArgs() {
		// TODO Auto-generated method stub
		return persistentClass.getArgs();
	}

	public Object[] getInsertSelectArgs() {
		return persistentClass.getInsertSelectArgs();
	}
	
	public String[] getInsertColumnNames(){
		return persistentClass.getInsertColumnNames();
	}
	
	public String[] getSelectColumns(){
		return persistentClass.getSelectColumns();
	}
	
	public String generateInsertSelectFromString(){
		InsertWithSelect insert = new InsertWithSelect().setInsertTableName(getTableName()+"History");
		insert.setSelectTableName(getTableName());
		insert.setInsertColumnNames(getInsertColumnNames());
		insert.setSelectColumns(getSelectColumns());
		List<List<String>> ORConditionMapList = getORConditionsMapList();
		insert.setORConditionMapList(ORConditionMapList);
		return insert.toInsertSelectFromStatementString();
	}

	public boolean needHistory() {
		// TODO Auto-generated method stub
		return persistentClass.getNeedHistory();
	}
}
