package com.cim.idm.framework.orm.info.access;

import java.lang.reflect.Field;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;



public class FieldAccessor
{

	public FieldAccessor()
	{
		try
		{
			Field[] fields = this.getClass().getDeclaredFields();
			for (Field field : fields)
			{
				Class<?> type = field.getType();
				
				field.setAccessible(true);
				if (field.get(this) != null)
					continue;
				if (type.equals(String.class))
					field.set(this, "");
				else if (type.equals(Map.class))
					field.set(this, new HashMap());
				else if (type.equals(List.class))
					field.set(this, new ArrayList());
				else if ( type.isArray() || type.equals( Timestamp.class ))
					continue;
				else
				{
					try
					{
						field.set(this, type.newInstance());
					} catch (Exception e)
					{}
				}
				
				field.setAccessible(false);
			}
		} catch (Exception e)
		{}
	}

	@Override
	public String toString()
	{
		try
		{
			StringBuilder builder = new StringBuilder();
			builder.append("{");
			Field[] fields = this.getClass().getDeclaredFields();
			for (Field field : fields)
			{
				field.setAccessible(true);
				builder.append(field.getName());
				builder.append("=");
				builder.append(field.get(this));
				builder.append(", ");
				field.setAccessible(false);
			}
			if (builder.substring(builder.length() - 2).equals(", "))
			{
				builder.delete(builder.length() - 2, builder.length());
			}
			builder.append("}");
			return builder.toString();
		} catch (Exception e)
		{
			return super.toString();
		}
	}

}
