package com.cim.idm.framework.orm.service;

import com.cim.idm.framework.exception.ext.DuplicateNameSignal;
import com.cim.idm.framework.exception.ext.FrameworkErrorSignal;
import com.cim.idm.framework.exception.ext.NotFoundSignal;
import com.cim.idm.framework.orm.info.DataInfo;
import com.cim.idm.framework.orm.info.KeyInfo;

/**
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.orm.service
 *  NAME    : CommonDataService.java
 *  TYPE    : JAVA
 *  DESCRIPTION : An extension of the Common service
 *
 ****************************************************************************
 */

public interface CommonDataService<KEY extends KeyInfo, DATA extends DataInfo> extends CommonService<KEY, DATA>
{

	public void create(DATA data, String user, String comment)
			throws NotFoundSignal, DuplicateNameSignal, FrameworkErrorSignal;

	public void changeData(DATA data, String user, String comment) throws NotFoundSignal, FrameworkErrorSignal;

}
