package com.cim.idm.framework.shutdown;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Component;

import com.cim.idm.framework.IDMFrameServiceProxy;
import com.cim.idm.framework.util.service.ServiceUtil;


public class ShutdownableShutdowner implements Runnable
{
	private Log	logger		= LogFactory.getLog( this.getClass());
	
	private int shutdownableTimeout = 5000;

	private ApplicationContext applicationContext;
	
	public int getShutdownableTimeout() {
		return shutdownableTimeout;
	}

	public void setShutdownableTimeout(int shutdownableTimeout) {
		this.shutdownableTimeout = shutdownableTimeout;
	}

	public ShutdownableShutdowner()
	{
	}
	
	public ShutdownableShutdowner( int shutdownableTimeout )
	{
		this.shutdownableTimeout = shutdownableTimeout;
	}
	

	public ShutdownableShutdowner setApplicationContext(ApplicationContext applicationContext) {
		this.applicationContext = applicationContext;
		return this;
	}
	
	@Override
	public void run()
	{
		List<Shutdownable> services = ServiceUtil.getServices(applicationContext, Shutdownable.class);
		
		if ( services == null )
			logger.info( "No Shutdownable" );
		else
		{
			for ( Object service : services )
			{
				try
				{
					Shutdownable shutdownable = ( Shutdownable )service;
					
					logger.info("Closing shutdownable [" + shutdownable.getName() + "]" );
					shutdownable.shutdown( shutdownableTimeout );
				}
				catch ( Exception ex )
				{
					logger.error( ex, ex );
				}
			}
		}
	}
}
