package com.cim.idm.framework.template.formatter;

import javax.jms.Message;

import com.cim.idm.framework.event.AbstractMessageEventTemplate;
import com.cim.idm.framework.util.msg.DocumentMessageUtil;
import com.cim.idm.framework.util.service.IDMFrameProperties;
import com.cim.idm.framework.util.xml.JdomUtils;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jdom.Document;

import com.tibco.tibrv.TibrvMsg;

public class MessageFormatter extends AbstractMessageEventTemplate
{

	private static Log	log				= LogFactory.getLog(MessageFormatter.class);
	private String		dataField_TAG	= System.getProperty(IDMFrameProperties.TibMsg_DataField);

	public MessageFormatter()
	{
	}

	public void onReceiveMessage(String beanName, Object data)
	{
		try
		{
			Document document = null;
			if ( data instanceof TibrvMsg )
			{
				document = DocumentMessageUtil.getDocumentFromTibrvMsg((TibrvMsg) data, dataField_TAG);
				log.info("RCRQ : " + JdomUtils.toString(document));
			}
			else if ( data instanceof Message )
			{
				document = DocumentMessageUtil.getDocumentFromJmsMessage((Message) data);
			}
//			else if ( data instanceof com.miracom.oneoone.transceiverx.Message )
//			{
//				com.miracom.oneoone.transceiverx.Message msg = (com.miracom.oneoone.transceiverx.Message) data;
//				byte[] bs = (byte[]) msg.getData();
//				String recvMsg = new String(bs);
//				MDC.put("NT.TRXID", StringUtils.substringBetween(recvMsg, "<transactionid>", "</transactionid>"));
//				log.info("RCRQ : " + recvMsg);
//				document = JdomUtils.loadText(recvMsg);
//			}

			Object[] arguments = new Object[] { document };

			execute(arguments);
		}
		catch ( Exception e )
		{
			log.error("", e);
		}
	}
}