package com.cim.idm.framework.template.workflow;

import java.util.List;

import org.jaxen.Context;
import org.jaxen.Function;
import org.jaxen.FunctionCallException;
import org.jaxen.XPathFunctionContext;
import org.springframework.beans.BeanWrapperImpl;

import com.cim.idm.flowpackage.expression.ExtendedFunction;

/*
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.template.idmworkflow
 *  NAME    : CustomFunction.java
 *  TYPE    : JAVA
 *  DESCRIPTION :
 *
 ****************************************************************************
 */

public class CustomFunction
		extends ExtendedFunction
{

	@Override
	public void registerFunctions(XPathFunctionContext functionContext)
	{
		functionContext.registerFunction(null, "newInstance", new NewInstance());
		functionContext.registerFunction(null, "setV", new SetV());
	}

	private class NewInstance
			implements Function
	{

		@Override
		public Object call(Context arg0, List arg1)
				throws FunctionCallException
		{
			try
			{
				return Class.forName(arg1.get(0).toString()).newInstance();
			}
			catch ( Exception e )
			{
				throw new FunctionCallException(e);
			}
		}

	}

	private class SetV
			implements Function
	{

		@Override
		public Object call(Context arg0, List arg1)
				throws FunctionCallException
		{
			Object o = arg1.get(0);
			
			BeanWrapperImpl beanWrapper = new BeanWrapperImpl(o);
			beanWrapper.setPropertyValue((String) arg1.get(1), arg1.get(2));
			
			return o;
		}

	}
}
