package com.cim.idm.framework.tool.logger;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

import org.springframework.util.StopWatch;

public class LogParser
{

	private static LogParser					instance;
	private ThreadPoolExecutor					threadPool	= null;
	private final ArrayBlockingQueue<Runnable>	queue		= new ArrayBlockingQueue<Runnable>(5);

	public static LogParser getInstance()
	{
		if (instance == null)
			instance = new LogParser();
		return instance;
	}

	public void runTask(Runnable task)
	{
		threadPool.execute(task);
		System.out.println("Task count.." + queue.size());
	}

	public LoggingEntity parserLogFile(String... logFileName)
	{
		LoggingEntity motherloggingEntity = new LoggingEntity();

		threadPool = new ThreadPoolExecutor(logFileName.length, logFileName.length, 10, TimeUnit.SECONDS, queue);

		for (int i = 0; i < logFileName.length; i++)
		{
			LogParserRunnable logParserRunnable = new LogParserRunnable(motherloggingEntity, logFileName[i]);
			threadPool.execute(logParserRunnable);
		}

		StopWatch clock = new StopWatch("parsing log files ....");
		clock.start();
		while (motherloggingEntity.parsedLogFiles < logFileName.length)
		{
			try
			{
				Thread.sleep(30);
			} catch (Exception e)
			{}
		}
		clock.stop();
		System.out.println(clock.shortSummary());

		if (logFileName.length > 1)
			motherloggingEntity.sort("");
		/*
		 * System.out.println("***** before sorting *****"); for (int i=0;
		 * i<motherloggingEntity.getBpelList().size(); i++) {
		 * System.out.println(motherloggingEntity.getBpelList().get(i).startTime); }
		 * 
		 * motherloggingEntity.sortByTime();
		 * 
		 * System.out.println("***** after sorting *****"); for (int i=0;
		 * i<motherloggingEntity.getBpelList().size(); i++) {
		 * System.out.println(motherloggingEntity.getBpelList().get(i).startTime); }
		 */

		return motherloggingEntity;
	}

	private LoggingEntity parserByBufferedReader(String logFileName)
	{
		StopWatch clock = new StopWatch("parserByBufferedReader");
		clock.start();
		LoggingEntity loggingEntity = new LoggingEntity();
		int cnt = 0;
		try
		{
			FileReader fr = new FileReader(logFileName);
			BufferedReader br = new BufferedReader(fr);
			String message = "";
			while (true)
			{
				message = br.readLine();
				if (message != null)
				{
					loggingEntity.add(message, cnt);
					cnt++;
				}
				else
				{
					break;
				}
			}
			loggingEntity.getBpelList().trimToSize();
			br.close();
			clock.stop();
			System.out.println(clock.shortSummary());
		} catch (IOException e)
		{
			System.err.println(cnt);
			System.err.println(e);
		}
		loggingEntity.rowCnt = cnt;
		return loggingEntity;
	}

}
