package com.cim.idm.framework.tool.logger;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

import org.springframework.util.StopWatch;

public class LogParserRunnable implements Runnable
{

	String			logFileName		= "";
	LoggingEntity	motherEntity	= null;

	public LogParserRunnable(LoggingEntity motherEntity, String logFileName)
	{
		this.logFileName = logFileName;
		this.motherEntity = motherEntity;
	}

	public void run()
	{
		StopWatch clock = new StopWatch("parserByBufferedReader");
		clock.start();
		LoggingEntity loggingEntity = new LoggingEntity();
		int cnt = 0;
		try
		{
			FileReader fr = new FileReader(this.logFileName);
			BufferedReader br = new BufferedReader(fr);
			String message = "";
			while (true)
			{
				message = br.readLine();
				if (message != null)
				{
					loggingEntity.add(message, cnt);
					cnt++;
				}
				else
				{
					break;
				}
			}

			loggingEntity.getBpelList().trimToSize();
			br.close();
			clock.stop();
			System.out.println(clock.shortSummary());
		} catch (IOException e)
		{
			System.err.println(cnt);
			System.err.println(e);
		}
		loggingEntity.rowCnt = cnt;
		this.motherEntity.addChildLoggingEntity(loggingEntity);
	}

}
