package com.cim.idm.framework.tool.logger;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import com.cim.idm.framework.util.sys.SystemPropHelper;


public class LoggingDataManager
{

	private LoggingEntity	loggingEntity;

	public LoggingDataManager(LoggingEntity loggingEntity)
	{
		this.loggingEntity = loggingEntity;
	}

	public ArrayList<BpelLoggingEntity> getBpels()
	{
		return this.loggingEntity.getBpelList();
	}

	public void setBpels(ArrayList<BpelLoggingEntity> bpels)
	{
		this.loggingEntity.setBpelList(bpels);
	}

	public List<BpelLoggingEntity> sortByElapseTime()
	{
		LogComparator logComparator = new LogComparator();
		logComparator.setSortingKey(LogComparator.SORT_ELAPSETIME);
		Collections.sort(this.loggingEntity.getBpelList(), logComparator);
		for (int i = 0; i < this.loggingEntity.getBpelList().size(); i++)
		{
			this.loggingEntity.getBpelList().get(i).setId(i);
		}
		return this.loggingEntity.getBpelList();
	}

	public List<BpelLoggingEntity> sortBySqlCnt()
	{
		LogComparator logComparator = new LogComparator();
		logComparator.setSortingKey(LogComparator.SORT_SQLCNT);
		Collections.sort(this.loggingEntity.getBpelList(), logComparator);
		for (int i = 0; i < this.loggingEntity.getBpelList().size(); i++)
		{
			this.loggingEntity.getBpelList().get(i).setId(i);
		}
		return this.loggingEntity.getBpelList();
	}

	public List<BpelLoggingEntity> sortByTime()
	{
		LogComparator logComparator = new LogComparator();
		logComparator.setSortingKey(LogComparator.SORT_STARTTIME);
		Collections.sort(this.loggingEntity.getBpelList(), logComparator);
		for (int i = 0; i < this.loggingEntity.getBpelList().size(); i++)
		{
			this.loggingEntity.getBpelList().get(i).setId(i);
		}
		return this.loggingEntity.getBpelList();
	}

	public List<BpelLoggingEntity> getBpelListOnlyFail()
	{
		List<BpelLoggingEntity> logData = new ArrayList<BpelLoggingEntity>();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (!loggingEntity.getBpelList().get(i).success)
				logData.add(loggingEntity.getBpelList().get(i));
		}
		//if (overwrite) loggingEntity.setBpelList(logData);
		return logData;
	}

	public List<String> getLogDataAll(BpelLoggingEntity bpelLoggingEntity)
	{
		return bpelLoggingEntity.getLogMsgList();
	}

	/*
	 * public List<String> getLogDataAll(BpelLoggingEntity bpelLoggingEntity) { List<String> logData
	 * = new ArrayList<String>(); boolean messageFind = false; for (int
	 * j=bpelLoggingEntity.startRowCnt; j<=bpelLoggingEntity.endRowCnt; j++) { if
	 * (loggingEntity.getLogWholeList().get(j).equalsIgnoreCase("<Envelop>")) messageFind = true;
	 * else if (loggingEntity.getLogWholeList().get(j).equalsIgnoreCase("</Envelop>")) { messageFind
	 * = false; continue; } if (!messageFind) logData.add(loggingEntity.getLogWholeList().get(j)); }
	 * return logData; }
	 */

	public List<String> getActivityNameList(BpelLoggingEntity bpelLoggingEntity)
	{
		return bpelLoggingEntity.getActivityList();
	}

	public List<String> getLogDataActivityList(BpelLoggingEntity bpelLoggingEntity)
	{
		return bpelLoggingEntity.getActivityLogDataList();
	}

	public String toString(List<String> logList)
	{
		StringBuffer strBuffer = new StringBuffer();
		for (int i = 0; i < logList.size(); i++)
		{
			strBuffer.append(logList.get(i)).append(SystemPropHelper.CR);
		}
		return strBuffer.toString();
	}

	public List<String> getBpelNameList()
	{
		List<String> logData = new ArrayList<String>();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (!logData.contains(loggingEntity.getBpelList().get(i).bpelName))
				logData.add(loggingEntity.getBpelList().get(i).bpelName);
		}
		return logData;
	}

	public List<BpelLoggingEntity> getTopElapseTime()
	{
		return null;
		//bpelList.get(i)
	}

	public List<BpelLoggingEntity> getBpelListByBpelName(String bpelName)
	{
		List<BpelLoggingEntity> logData = new ArrayList<BpelLoggingEntity>();
		if (bpelName == null)
			return this.loggingEntity.getBpelList();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (loggingEntity.getBpelList().get(i).bpelName.startsWith(bpelName + "@"))
			{
				logData.add(loggingEntity.getBpelList().get(i));
			}
		}
		return logData;
	}

	public List<BpelLoggingEntity> getBpelListByFromTime(String FromDate)
	{
		long fromStartingTime = 0;
		java.util.Date aDate = null;
		try
		{
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
			if (FromDate.length() == 13)
				aDate = sdf.parse(FromDate + ":00:00");
			else if (FromDate.length() == 16)
				aDate = sdf.parse(FromDate + ":00");
			else
				aDate = sdf.parse(FromDate);
			fromStartingTime = aDate.getTime();
		} catch (Exception e)
		{
			System.out.println(e);
			return this.loggingEntity.getBpelList();
		}

		List<BpelLoggingEntity> logData = new ArrayList<BpelLoggingEntity>();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (loggingEntity.getBpelList().get(i).startTimeLong >= fromStartingTime)
			{
				logData.add(loggingEntity.getBpelList().get(i));
			}
		}
		return logData;
	}

	public List<BpelLoggingEntity> getBpelListByToTime(String ToDate)
	{
		long fromStartingTime = 0;
		java.util.Date aDate = null;
		try
		{
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
			if (ToDate.length() == 13)
				aDate = sdf.parse(ToDate + ":00:00");
			else if (ToDate.length() == 16)
				aDate = sdf.parse(ToDate + ":00");
			else
				aDate = sdf.parse(ToDate);
			fromStartingTime = aDate.getTime();
		} catch (Exception e)
		{
			System.out.println(e);
			return this.loggingEntity.getBpelList();
		}

		List<BpelLoggingEntity> logData = new ArrayList<BpelLoggingEntity>();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (loggingEntity.getBpelList().get(i).startTimeLong <= fromStartingTime)
			{
				logData.add(loggingEntity.getBpelList().get(i));
			}
		}
		return logData;
	}

	public List<BpelLoggingEntity> getBpelListByFromToTime(String FromDate, String ToDate)
	{
		long toStartingTime = 0;
		long fromStartingTime = 0;
		java.util.Date aDate = null;

		String[] times = new String[] { FromDate, ToDate };
		for (int i = 0; i < times.length; i++)
		{
			try
			{
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
				if (times[i].length() == 13)
					aDate = sdf.parse(times[i] + ":00:00");
				else if (ToDate.length() == 16)
					aDate = sdf.parse(times[i] + ":00");
				else
					aDate = sdf.parse(times[i]);
				if (i == 0)
					fromStartingTime = aDate.getTime();
				else
					toStartingTime = aDate.getTime();
			} catch (Exception e)
			{
				System.out.println(e);
				return this.loggingEntity.getBpelList();
			}
		}

		List<BpelLoggingEntity> logData = new ArrayList<BpelLoggingEntity>();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (loggingEntity.getBpelList().get(i).startTimeLong >= fromStartingTime
				&& loggingEntity.getBpelList().get(i).startTimeLong <= toStartingTime)
			{
				logData.add(loggingEntity.getBpelList().get(i));
			}
		}
		return logData;
	}

	public List<BpelLoggingEntity> getBpelListByAppName(String appName)
	{
		List<BpelLoggingEntity> logData = new ArrayList<BpelLoggingEntity>();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (loggingEntity.getBpelList().get(i).appName.equalsIgnoreCase(appName))
			{
				logData.add(loggingEntity.getBpelList().get(i));
			}
		}
		return logData;
	}

	public List<BpelLoggingEntity> getBpelListByCondition(String bpelName, String equipmentid, String lotName)
	{
		List<BpelLoggingEntity> logData = new ArrayList<BpelLoggingEntity>();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (loggingEntity.getBpelList().get(i).bpelName.equalsIgnoreCase(bpelName)
				&& loggingEntity.getBpelList().get(i).equipment.equalsIgnoreCase(equipmentid)
				&& loggingEntity.getBpelList().get(i).lotName.equalsIgnoreCase(lotName))
			{
				logData.add(loggingEntity.getBpelList().get(i));
			}
		}
		return logData;
	}

	public List<BpelLoggingEntity> getBpelListByCondition(String equipmentid, String lotName)
	{
		List<BpelLoggingEntity> logData = new ArrayList<BpelLoggingEntity>();
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			if (equipmentid != null && equipmentid.length() > 0 && lotName != null && lotName.length() > 0)
			{
				if (loggingEntity.getBpelList().get(i).equipment.equalsIgnoreCase(equipmentid)
					&& loggingEntity.getBpelList().get(i).lotName.equalsIgnoreCase(lotName))
				{
					logData.add(loggingEntity.getBpelList().get(i));
				}
			}
			else if (equipmentid != null && equipmentid.length() > 0)
			{
				if (loggingEntity.getBpelList().get(i).equipment.equalsIgnoreCase(equipmentid))
				{
					logData.add(loggingEntity.getBpelList().get(i));
				}
			}
			else if (lotName != null && lotName.length() > 0)
			{
				if (loggingEntity.getBpelList().get(i).lotName.equalsIgnoreCase(lotName))
				{
					logData.add(loggingEntity.getBpelList().get(i));
				}
			}
		}
		return logData;
	}

	//	public void sorting(LoggingEntity ... LoggingEntity)
	//	{
	//		
	//		
	//		return null;
	//	}

	//	public List<String> getBpelLogData(String bpelName, int startRowCnt)
	//	{
	//		List<String> logData = new ArrayList<String>();
	//		for (int i=0; i<bpelList.size(); i++)
	//		{
	//			if (bpelList.get(i).bpelName.equalsIgnoreCase(bpelName) && bpelList.get(i).startRowCnt == startRowCnt)
	//			{
	//				for (int j=startRowCnt; j<bpelList.get(i).endRowCnt; j++)
	//				{
	//					logData.add(logFullList.get(j));
	//				}
	//				break;
	//			}
	//		}
	//		return logData;
	//	}

}
