package com.cim.idm.framework.tool.logger;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;

import com.cim.idm.framework.IDMFrameServiceProxy;
import com.cim.idm.framework.fos.idmflow.BpelLogger;

public class LoggingEntity
{
	private ArrayList<BpelLoggingEntity>	bpelList;
	public int								rowCnt				= 0;

	private AppNamesBpelMap					appNameAndBpelMap	= new AppNamesBpelMap();

	public int								parsedLogFiles		= 0;

	public LoggingEntity()
	{
		bpelList = new ArrayList<BpelLoggingEntity>();
	}

	public void addChildLoggingEntity(LoggingEntity loggingEntity)
	{
		for (int i = 0; i < loggingEntity.getBpelList().size(); i++)
		{
			this.bpelList.add(loggingEntity.getBpelList().get(i));
			loggingEntity.getBpelList().get(i).setId(this.bpelList.size() - 1);
		}
		++parsedLogFiles;
		//this.bpelList.addAll(loggingEntity.getBpelList());
	}

	public void sort(String key)
	{
		LogComparator logComparator = new LogComparator();
		if (key == null || key.length() == 0)
			key = "startTimeLong";
		logComparator.setSortingKey(key);
		Collections.sort(this.bpelList, logComparator);
		for (int i = 0; i < this.bpelList.size(); i++)
		{
			this.bpelList.get(i).setId(i);
		}
	}

	public void parseEnd()
	{
		appNameAndBpelMap.clear();
	}

	public ArrayList<BpelLoggingEntity> getBpelList()
	{
		return this.bpelList;
	}

	public void setBpelList(ArrayList<BpelLoggingEntity> list)
	{
		this.bpelList.clear();
		this.bpelList = list;
	}

	public void toSummary()
	{
		System.out.println("**************************************************************************");
		System.out.println("RowCnt = " + this.rowCnt);
		System.out.println("BPEL Find Cnt = " + this.bpelList.size());
		System.out.println("**************************************************************************");
	}

	//The point to note here because it is one of the log file to be shared by multiple servers, Log files must be extracted to fit the correct server and BPEL.
	public void add(String log, int rowCnt)
	{
		String appName = getAppName(log);
		String threadId = getThreadId(log);
		threadId = threadId.trim();
		
//		if(IDMFrameServiceProxy.isPossibleIDMFlow())
//		{
		if (log.indexOf(BpelLogger.bpel_started) > 0) {
			BpelLoggingEntity bpelLoggingEntity = new BpelLoggingEntity();
			parseBpelStarted(log, bpelLoggingEntity);
			appNameAndBpelMap.addBpelLoggingEntity(appName, threadId,bpelLoggingEntity);
		} else if (log.indexOf(BpelLogger.bpel_ended) > 0) {
			BpelLoggingEntity bpelLoggingEntity = appNameAndBpelMap.remove(appName, threadId);
			if (bpelLoggingEntity != null) {
				parseBpelEnded(log, bpelLoggingEntity);
				bpelList.add(bpelLoggingEntity);
				bpelLoggingEntity.setId(bpelList.size() - 1);
				bpelLoggingEntity.add(log);
			}
		} else if (log.indexOf(BpelLogger.bpel_activity_started) > 0) {
			BpelLoggingEntity bpelLoggingEntity = appNameAndBpelMap.getBpelLoggingEntity(appName, threadId);
			if (bpelLoggingEntity != null) {
				bpelLoggingEntity.addActivityHistory(
						parseBpelActivityStarted(log, bpelLoggingEntity),
						rowCnt, log);
			}
		} else if (log.indexOf(BpelLogger.bpel_activity_ended) > 0) {
		} else if (log.indexOf(BpelLogger.sqlExecutor) > 0) {
			BpelLoggingEntity bpelLoggingEntity = appNameAndBpelMap.getBpelLoggingEntity(appName, threadId);
			if (bpelLoggingEntity != null) {
				bpelLoggingEntity.sqlCnt = bpelLoggingEntity.sqlCnt + 1;
			}
		}
//		}
//		else
//		{
//			if (log.indexOf(com.cim.idm.framework.fos.nanoflow.BpelLogger.bpel_started) > 0)
//			{
//				BpelLoggingEntity bpelLoggingEntity = new BpelLoggingEntity();
//				parseBpelStarted(log, bpelLoggingEntity);
//				appNameAndBpelMap.addBpelLoggingEntity(appName, threadId, bpelLoggingEntity);
//			}
//			else if (log.indexOf(com.cim.idm.framework.fos.nanoflow.BpelLogger.bpel_ended) > 0)
//			{
//				BpelLoggingEntity bpelLoggingEntity = appNameAndBpelMap.remove(appName, threadId);
//				if (bpelLoggingEntity != null)
//				{
//					parseBpelEnded(log, bpelLoggingEntity);
//					bpelList.add(bpelLoggingEntity);
//					bpelLoggingEntity.setId(bpelList.size() - 1);
//					bpelLoggingEntity.add(log);
//				}
//			}
//			else if (log.indexOf(com.cim.idm.framework.fos.nanoflow.BpelLogger.bpel_activity_started) > 0)
//			{
//				BpelLoggingEntity bpelLoggingEntity = appNameAndBpelMap.getBpelLoggingEntity(appName, threadId);
//				if (bpelLoggingEntity != null)
//				{
//					bpelLoggingEntity.addActivityHistory(parseBpelActivityStarted(log, bpelLoggingEntity), rowCnt, log);
//				}
//			}
//			else if (log.indexOf(com.cim.idm.framework.fos.nanoflow.BpelLogger.bpel_activity_ended) > 0)
//			{}
//			else if (log.indexOf(com.cim.idm.framework.fos.nanoflow.BpelLogger.sqlExecutor) > 0)
//			{
//				BpelLoggingEntity bpelLoggingEntity = appNameAndBpelMap.getBpelLoggingEntity(appName, threadId);
//				if (bpelLoggingEntity != null)
//				{
//					bpelLoggingEntity.sqlCnt = bpelLoggingEntity.sqlCnt + 1;
//				}
//			}
//		}
		/*
		 * else if (log.indexOf(LogConstant.bpel_req_message) > 0) { //bpelName =
		 * getBpelName(log, LogConstant.bpel_req_message); BpelLoggingEntity bpelLoggingEntity =
		 * appNameAndBpelMap.getBpelLoggingEntity(appName); if (bpelLoggingEntity != null) {
		 * messageFindOK = true; } } else { if (messageFindOK) {
		 * messageBuffer.append(log).append(SystemPropHelper.CR); if (log.indexOf("</Envelop>") >=
		 * 0) { BpelLoggingEntity bpelLoggingEntity =
		 * appNameAndBpelMap.getBpelLoggingEntity(appName); bpelLoggingEntity.message =
		 * messageBuffer.toString(); messageBuffer.setLength(0); messageFindOK = false; } } }
		 */

		BpelLoggingEntity bpelLoggingentity = appNameAndBpelMap.getBpelLoggingEntity(appName, threadId);
		if (bpelLoggingentity != null)
			bpelLoggingentity.add(log);

		++rowCnt;

	}

	private String getItem(String fullMessage, String skeyName, String eKeyName)
	{
		int index = fullMessage.indexOf(skeyName);
		if (index < 0)
			return "";
		String strSub = fullMessage.substring(index + skeyName.length() + 1, fullMessage.length());
		int index2 = strSub.indexOf(eKeyName);
		return strSub.substring(0, index2);

	}

	private String	previousAppName	= "";

	private String getAppName(String log)
	{
		try
		{
			String subString = log.substring(24, 24 + 30);
			String name = getItem(subString, "Id", " ");
			if (name != null && name.length() > 0)
				previousAppName = getItem(subString, "Id", " ");
			return previousAppName;
		} catch (Exception e)
		{
			return previousAppName;
		}
	}

	private String	previousThreadId	= "";

	private String getThreadId(String log)
	{
		//log = "                <SEQUENCE_NAME><![CDATA[ValidateUserFunc]]></SEQUENCE_NAME>";	
		try
		{
			String subString = log.substring(24, 24 + 50);
			String name = getItem(subString, "thread=[", "]");
			if (name != null && name.length() > 0)
				previousThreadId = name;
			return previousThreadId;
		} catch (Exception e)
		{}
		return previousThreadId;
	}

	private String parseBpelActivityStarted(String log, BpelLoggingEntity bpelLoggingEntity)
	{
		int index = log.indexOf(bpelLoggingEntity.bpelName);
		if (index > 0)
		{
			return log.substring(index + bpelLoggingEntity.bpelName.length() + 4, log.length());
		}
		return "";
	}

	private void parseBpelEnded(String log, BpelLoggingEntity bpelLoggingEntity)
	{
		if (log.indexOf("<SUCCESS>") > 0)
			bpelLoggingEntity.success = true;
		else
			bpelLoggingEntity.success = false;
		bpelLoggingEntity.elapseTime = getItem(log, "Elapsed Time =", " ");
	}

	private void parseBpelStarted(String log, BpelLoggingEntity bpelLoggingEntity)
	{
		int index = log.indexOf(BpelLogger.bpel_started);
		String strMessage = log.substring(index + BpelLogger.bpel_started.length());
		index = strMessage.indexOf(" ");
		bpelLoggingEntity.bpelName = strMessage.substring(0, index).trim();
		try
		{
			bpelLoggingEntity.equipment = getItem(log, BpelLogger.bpel_equipmentid, " ");
		} catch (Exception e)
		{
			bpelLoggingEntity.equipment = "";
		}
		try
		{
			bpelLoggingEntity.lotName = getItem(log, BpelLogger.bpel_lotname, "]");
		} catch (Exception e)
		{
			bpelLoggingEntity.lotName = "";
		}
		// 2008-02-11 14:38:44,156
		try
		{
			bpelLoggingEntity.startTime = log.substring(0, 23);
		} catch (Exception e)
		{}

		try
		{
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
			java.util.Date aDate =
					sdf.parse(bpelLoggingEntity.startTime.substring(0, bpelLoggingEntity.startTime.length() - 4));
			bpelLoggingEntity.startTimeLong = aDate.getTime();
			//System.out.println(bpelLoggingEntity.startTimeLong);
		} catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	//	private String toString(List<String> names, String delimeter)
	//	{
	//		String data = "";
	//		for (int i=0; i<names.size(); i++)
	//		{
	//			data += names.get(i) + delimeter;
	//		}
	//		return data.substring(0, data.length()-1);
	//	}

}
