package com.cim.idm.framework.transaction;

import org.springframework.transaction.support.DefaultTransactionDefinition;

/**
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.orm.service
 *  NAME    : IsolationLevel.java
 *  TYPE    : JAVA
 *  DESCRIPTION : Level to allow for inconsistent data
 *
 ****************************************************************************
 */

public enum IsolationLevel
{
	ISOLATION_DEFAULT( DefaultTransactionDefinition.ISOLATION_DEFAULT ), 
	ISOLATION_READ_UNCOMMITTED( DefaultTransactionDefinition.ISOLATION_READ_UNCOMMITTED ), 
	ISOLATION_READ_COMMITTED( DefaultTransactionDefinition.ISOLATION_READ_COMMITTED ), 
	ISOLATION_REPEATABLE_READ( DefaultTransactionDefinition.ISOLATION_REPEATABLE_READ ), 
	ISOLATION_SERIALIZABLE( DefaultTransactionDefinition.ISOLATION_SERIALIZABLE	);

	private int	level;

	public int value()
	{
		return level;
	}

	IsolationLevel( int value )
	{
		level = value;
	}
}
