package com.cim.idm.framework.transaction;

import org.springframework.transaction.support.DefaultTransactionDefinition;

/**
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.orm.service
 *  NAME    : PropagationBehavior.java
 *  TYPE    : JAVA
 *  DESCRIPTION : propagation of transaction is used to set the rules.
 *
 ****************************************************************************
 */

public enum PropagationBehavior
{
	PROPAGATION_REQUIRED( DefaultTransactionDefinition.PROPAGATION_REQUIRED ), 
	PROPAGATION_SUPPORTS( DefaultTransactionDefinition.PROPAGATION_SUPPORTS ), 
	PROPAGATION_MANDATORY( DefaultTransactionDefinition.PROPAGATION_MANDATORY ), 
	PROPAGATION_REQUIRES_NEW( DefaultTransactionDefinition.PROPAGATION_REQUIRES_NEW ), 
	PROPAGATION_NOT_SUPPORTED( DefaultTransactionDefinition.PROPAGATION_NOT_SUPPORTED ), 
	PROPAGATION_NEVER( DefaultTransactionDefinition.PROPAGATION_NEVER ), 
	PROPAGATION_NESTED( DefaultTransactionDefinition.PROPAGATION_NESTED );

	private int	behavior;

	public int value()
	{
		return behavior;
	}

	PropagationBehavior(int value)
	{
		behavior = value;
	}
}
