package com.cim.idm.framework.transaction;

/**
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.orm.service
 *  NAME    : PropagationBehavior.java
 *  TYPE    : JAVA
 *  DESCRIPTION : Transaction Manager
 *
 ****************************************************************************
 */

public interface TransactionManager
{
	// start Transaction
	public void beginTransaction();
	// commit
	public void commitTransaction();
	// roll back
	public void rollbackTransaction();

	// All Commit
	public void commitAllTransactions();
	// All roll back
	public void rollbackAllTransactions();

	// Transaction processing method about whether to Auto or not
	public boolean isAutoManaged();
}
