package com.cim.idm.framework.util.file;

import java.io.IOException;
import java.io.OutputStream;
import java.util.Collection;
import java.util.Iterator;
import java.util.Map;

public class CollectionUtil
{

	/**
	 * collection to StringArray
	 * 
	 * @param collection
	 * @return
	 */
	public final static String[] toStringArray(final Collection collection)
	{

		final String[] result = new String[collection.size()];
		final Iterator iter = collection.iterator();
		int i = 0;
		while (iter.hasNext())
		{
			result[i] = iter.next().toString();
			i++;
		}
		return result;

	}

	/**
	 * Write OutputStream
	 * 
	 * @param collection
	 * @param out
	 * @throws IOException
	 */
	public final static void dump(final Collection collection, final OutputStream out) throws IOException
	{

		final Iterator iter = collection.iterator();
		int count = 0;
		while (iter.hasNext())
		{
			out.write(("[" + count + "] value[" + iter.next().toString() + "]" + System.getProperty("line.separator")).getBytes());
			count++;
		}
	}

	/**
	 * map to StringArray
	 * 
	 * @param map
	 * @return
	 */
	public final static String[] toStringArray(final Map map)
	{
		final String[] result = new String[map.size()];
		final Iterator iter = map.entrySet().iterator();
		int i = 0;
		while (iter.hasNext())
		{
			final Map.Entry entry = (Map.Entry) iter.next();
			result[i] = entry.getKey().toString() + "=" + entry.getValue().toString();
			i++;
		}
		return result;
	}

}
