package com.cim.idm.framework.util.file;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.util.file<br>
 *  NAME    : FileBaseWatcher.java<br>
 *  TYPE    : JAVA<br>
 *  DESCRIPTION : 
 *
 ****************************************************************************
 */

public class FileBaseWatcher extends TimerTask
{

	private static final Log	log							= LogFactory.getLog(FileBaseWatcher.class);
	private String				filePath					= null;
	private long				oldLogFileLastModifiedTime	= 0;
	private File				logFile						= null;
	private List<FileListener>	listenerList				= new ArrayList<FileListener>();
	private Timer				timer						= null;

	public void registerListener(FileListener listener)
	{
		listenerList.add(listener);
	}

	public FileBaseWatcher(String fileName)
	{
		this.filePath = fileName;
		logFile = new File(this.filePath);

		if (logFile.lastModified() != 0)
			oldLogFileLastModifiedTime = logFile.lastModified();
	}

	public void run()
	{
		long newLastModifiedTime = logFile.lastModified();

		if (oldLogFileLastModifiedTime != newLastModifiedTime)
		{
			//			if( log.isInfoEnabled() ) {
			//				//log.info("file changed [" + this.filePath + "] is re-loading");
			//			}

			oldLogFileLastModifiedTime = newLastModifiedTime;
			for (int i = 0; i < this.listenerList.size(); i++)
			{
				((FileListener) this.listenerList.get(i)).onFileChanged(new FileListenerEvent(this.filePath, "Modified"));
			}
		}
	}

}
