package com.cim.idm.framework.util.file;

import java.util.Date;
import java.util.Timer;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 ****************************************************************************
 *  PACKAGE : com.cim.idm.framework.util.file<br>
 *  NAME    : FileBaseWatcherManager.java<br>
 *  TYPE    : JAVA<br>
 *  DESCRIPTION : 
 *
 ****************************************************************************
 */

public class FileBaseWatcherManager
{

	private static final Log				log		= LogFactory.getLog(FileBaseWatcherManager.class);
	private Timer							timer	= null;
	private static FileBaseWatcherManager	instance;

	public static FileBaseWatcherManager getInstance()
	{
		if (instance == null)
			instance = new FileBaseWatcherManager();
		return instance;
	}

	public FileBaseWatcherManager()
	{
		super();
	}

	public void startFileMonitor(long refreshTime, String logFilePath, FileListener listener)
	{
		timer = new Timer();
		FileBaseWatcher fileWatcher = new FileBaseWatcher(logFilePath);
		fileWatcher.registerListener(listener);
		timer.schedule(fileWatcher, new Date(), refreshTime);
	}

	public void cancel()
	{
		if (timer != null)
		{
			timer.cancel();
		}

		if (log.isInfoEnabled())
		{
			log.info("Log4j Configuration Refresh Timer canceled");
		}
	}

}
