package com.cim.idm.framework.util.msg;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.json.JSONObject;
import org.jdom.Document;

import com.cim.idm.framework.util.xml.JdomUtils;
import com.jayway.jsonpath.JsonPath;

public class JsonMessageUtil {
	private static Log			log						= LogFactory.getLog(JsonMessageUtil.class);

	public static final String	Command_Tag				= "COMMAND";

	private static final String	ReplySubjectName_Tag	= "ORIGINALSOURCESUBJECTNAME";
	
	public static final String Root_Tag = "Message";

	public static final String Header_Tag = "Header";
	public static final String MessageName_Tag = "MESSAGENAME";
	public static final String TransactionID_Tag = "TRANSACTIONID";
	public static final String Listener_Tag = "listener";
	public static final String EventUser_Tag = "EVENTUSER";
	public static final String EventComment_Tag = "EVENTCOMMENT";
	public static final String Language_Tag = "LANGUAGE";

	public static final String Body_Tag = "Body";

	public static final String Result_Tag = "Return";
	public static final String Result_ReturnCode = "RETURNCODE";
	public static final String Result_ErrorMessage = "RETURNMESSAGE";
	
	/**
	 * Get the bpel Name from json string.
	 * @param doc
	 * @return BpelName
	 * @see
	 */
	public static String getBpelName(JSONObject jsonObject)
	{
		try
		{
			return JsonPath.read(jsonObject.toString(),"$."+Root_Tag+"."+Header_Tag+"."+MessageName_Tag); 
		} catch (Exception e)
		{}
		return "";
	}
}
