package com.cim.idm.framework.util.msg;

import java.util.Iterator;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.json.JSONArray;
import org.json.JSONObject;
import org.json.XML;

public class MessageConvertUtil {
	private static Log			log						= LogFactory.getLog(MessageConvertUtil.class);
	/**
	 * format a JSON string to XML string
	 * @param a JSON String
	 * @return XML format String
	 * @throws Exception
	 */
	public static String jsonToXml(String jsonStr) throws Exception {
		JSONObject jsonObject = new JSONObject(jsonStr);
		Element rootElement = null;
		String returnXml = null;
		if(jsonObject.getClass().equals(JSONObject.class)) {
			String[] keys = jsonObject.getNames(jsonObject);
		
			rootElement = DocumentHelper.createElement(keys[0]);
			
			jsonToElement(jsonObject.getJSONObject(keys[0]),rootElement);
		}else if(JSONArray.class.equals(jsonObject.getClass())) {
			
			log.error("JSON String should not begin with '['");
			
			throw new Exception("JSON String should not begin with '['");
		}
		if(rootElement != null) {
			Document doc  = DocumentHelper.createDocument(rootElement);
			returnXml = doc.asXML();
		}
		return returnXml;
	}
	
	/**
	 * format a JSONObject to XML String
	 * @param jsonObject
	 * @return XML format String
	 * @throws Exception
	 */
	public static String jsonToXml(JSONObject jsonObject) throws Exception {
		Element rootElement = null;
		String returnXml = null;
		String[] keys = jsonObject.getNames(jsonObject);
		rootElement = DocumentHelper.createElement(keys[0]);
		jsonToElement(jsonObject.getJSONObject(keys[0]) ,rootElement );
		if (rootElement != null) {
			Document doc = DocumentHelper.createDocument(rootElement);
			returnXml = doc.asXML();
		}
		return returnXml;
	}
	
	
	/**
	 * format a jsonObject to a XML element
	 * @param body
	 * @param jsonObject
	 */
	public static void jsonToElement(JSONObject jsonObject,Element element) {
		Iterator<String> iterator = jsonObject.keySet().iterator();
		while(iterator.hasNext()) {
			String key = iterator.next();
			Object jsonChild = jsonObject.get(key);
			if(jsonChild.getClass().equals(JSONObject.class)) {
				Element child = DocumentHelper.createElement(key);
				element.add(child);
				jsonToElement((JSONObject)jsonChild ,child);
			}else if(JSONArray.class.equals(jsonChild.getClass())) {
				for(Object o : (JSONArray)jsonChild) {
					if(o instanceof JSONObject) {
						Element subChild = DocumentHelper.createElement(key);
						element.add(subChild);
						jsonToElement((JSONObject)o ,subChild);
					}else {
						Element subChild = DocumentHelper.createElement((key));
						element.add(subChild);
						subChild.addText(o.toString());
					}
				}
			}else {
				Element child = DocumentHelper.createElement(key);
				element.add(child);
				child.addText(jsonChild.toString());
			}
		}
	}

	public static boolean isEmpty(String str) {

		if (str == null || str.trim().isEmpty() || "null".equals(str)) {
			return true;
		}
		return false;
	}

	public static String xmlTojson(String xml) {
		JSONObject jsonObj = XML.toJSONObject(xml);
		
		return jsonObj.toString();
    }
}
