package com.cim.idm.framework.util.net;


/**
 * convert ip value between string and long <br/>
 * ipString2Long(String arg): to convert a string value ip to a long value<br/>
 * long2IpString(long arg): to concert a long value to a ip string<br/>
 * @author 111079
 * @apiNote usage:<br/>
 * &nbsp;&nbsp;long ip = IpUtil.ipString2Long("192.168.0.1")<br/>
 * &nbsp;&nbsp;String ipStr = IpUtil.long2IpString(3232235521L)<br/>
 */
public class IpUtil {

	public static String long2IpString(long ipLong) {
		StringBuilder ip = new StringBuilder();
		ip.append(ipLong >>> 24).append(".")
		  .append((ipLong >>> 16) & 0xFF).append(".")
		  .append((ipLong >>> 8) & 0xFF).append(".")
		  .append(ipLong & 0xFF);
		return ip.toString();
	}
	
	public static long ipString2Long(String ipStr) {
		String[] ipArray = ipStr.split("\\.");
		return (Long.valueOf(ipArray[0]) << 24) + (Long.valueOf(ipArray[1]) << 16)
			+(Long.valueOf(ipArray[2]) << 8) + Long.valueOf(ipArray[3]) ;
	}
	
	public static void main(String[] args) {
		System.out.println(ipString2Long("192.168.0.1"));
		System.out.println(long2IpString(3232235521L));
		System.out.println(ipString2Long(long2IpString(3232235521L)));
		
	}
	
}
